library( "Benchmarking" )
data<-read.csv("C:/Users/Irene/Desktop/Lab2dataset.csv", header=TRUE, sep=",")



# obtaining and decomposing productivity changes
data1997 <-data[ which(data$year == 1997),]
x1997<-with(data1997, cbind(Labour,Capital))
y1997<-with(data1997, cbind(GVA))
data1998 <-data[ which(data$year == 1998),]
x1998<-with(data1998, cbind(Labour,Capital))
y1998<-with(data1998, cbind(GVA))






# Following Fare et al., (1994)
#1997-1998
#	The efficiencies for period 0 with reference technology from period 0
c00<-eff(dea(x1997,y1997,RTS = "vrs"))

#The efficiencies for period 0 with reference technology from period 1
c01<-eff(dea(x1997,y1997,XREF = x1998,YREF = y1998,RTS = "vrs"))

#The efficiencies for period 1 with reference technology from period 1
c11<-eff(dea(x1998,y1998,RTS = "vrs"))

#The efficiencies for period 1 with reference technology from period 0
c10<-eff(dea(x1998,y1998,XREF = x1997,YREF = y1997,RTS="vrs"))


# productivity changes (Malmquist)
dProd0 <- c10 / c00
hist( dProd0 )
dProd1 <- c11 / c01
plot( dProd0, dProd1 )
dProd <- sqrt( dProd0 * dProd1 )

#or
dProd <-dTech* dEff


# technological changes
dTech0 <- c00 / c01
dTech1 <- c10 / c11
plot( dTech0, dTech1 )
dTech <- sqrt( dTech0 * dTech1 )

# efficiency changes
dEff <- c11 / c00
hist( dEff )

# checking Malmquist decomposition
all.equal( dProd, dTech * dEff )


#Malmquist Index
m<-malmq(x1997,y1997,ID0 = NULL,x1998,y1998,ID1 = NULL,RTS = "vrs")
print("Malmquist index for change in productivity:")
print(m$mq)
print("Index for technology change:")
print(m$tc)
print("Index for change of frontier:")
print(m$tc)

results9798<-data.frame(m$mq,m$tc,m$ec)


install.packages("productivity")
library(productivity)


pr<-malm(data = data,id.var = "regions",time.var = "year", x.vars=c("Capital","Labour"), y.vars=c("GVA"), orientation =  "in",tech.reg = TRUE, rts ="vrs")
#Shephard distance function estimates,useful to compute and decompose the Malmquist productivity index
pr$Levels
# Malmquist productivity index and its components are provided
pr$Changes
results2<-data.frame(pr$Changes)

